LightWayTxtParser Class Reference documentation

LightWayTxtParser Class Referencefinal

the main class to read a LightWay Text file More...

`#include <LightWayTxtParser.hxx>`

Inheritance diagram for LightWayTxtParser:

## Public Member Functions
| LightWayTxtParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~LightWayTxtParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions
void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches)
bool | getColumnInfo (int &numCols, int &colSep) const
| returns the number of column and the column separator (in point)
void | newPage (int number)
| adds a new page
bool | textInDataFork () const
| returns true if the main text is in data fork
void | sendGraphic (int graphId)
| ask the graph parser to send a graph
bool | sendHeaderFooter (bool header)
| try to send the header/footer
bool | createZones ()
| finds the different objects zones
bool | readPrintInfo (MWAWEntry const &entry)
| read a PrintInfo block
bool | readDocInfo (MWAWEntry const &entry)
| read a DocInfo block
bool | readDocument (MWAWEntry const &entry)
| read a Document, Header/Footer block (1000)
bool | readLWSR2 (MWAWEntry const &entry)
| read a LWSR block (1002)
bool | readMPSR5 (MWAWEntry const &entry)
| read a MPSR block (1005)
bool | readTOCPage (MWAWEntry const &entry)
| read a TOC page block
bool | readTOC (MWAWEntry const &entry)
| read a TOC data block
MWAWInputStreamPtr | rsrcInput ()
| return the input input
libmwaw::DebugFile & | rsrcAscii ()
| a DebugFile used to write what we recognize when we parse the document in rsrc
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes
std::shared_ptr< LightWayTxtParserInternal::State > | m_state
| the state
bool | m_pageSpanSet
| a flag to know if page span has been set
std::shared_ptr< LightWayTxtGraph > | m_graphParser
| the graph parser
std::shared_ptr< LightWayTxtText > | m_textParser
| the text parser

## Friends
class | LightWayTxtParserInternal::SubDocument
class | LightWayTxtGraph
class | LightWayTxtText

## Detailed Description

the main class to read a LightWay Text file

## Constructor & Destructor Documentation

## ◆ LightWayTxtParser()

LightWayTxtParser::LightWayTxtParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ◆ ~LightWayTxtParser()

LightWayTxtParser::~LightWayTxtParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool LightWayTxtParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by LightWayTxtText, and parse().

## ◆ createDocument()

void LightWayTxtParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by LightWayTxtText, and parse().

## ◆ createZones()

bool LightWayTxtParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by LightWayTxtText, and parse().

## ◆ getColumnInfo()

bool LightWayTxtParser::getColumnInfo | ( | int & | numCols,
|  | int & | colSep ) const
| protected

returns the number of column and the column separator (in point)

Referenced by LightWayTxtText.

## ◆ getPageLeftTop()

MWAWVec2f LightWayTxtParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

Referenced by LightWayTxtText.

## ◆ init()

void LightWayTxtParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by LightWayTxtParser(), and LightWayTxtText.

## ◆ newPage()

void LightWayTxtParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by LightWayTxtText.

## ◆ parse()

void LightWayTxtParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by LightWayTxtText.

## ◆ readDocInfo()

bool LightWayTxtParser::readDocInfo | ( | MWAWEntry const & | entry | ) |
| protected

read a DocInfo block

Referenced by createZones(), and LightWayTxtText.

## ◆ readDocument()

bool LightWayTxtParser::readDocument | ( | MWAWEntry const & | entry | ) |
| protected

read a Document, Header/Footer block (1000)

Referenced by createZones(), and LightWayTxtText.

## ◆ readLWSR2()

bool LightWayTxtParser::readLWSR2 | ( | MWAWEntry const & | entry | ) |
| protected

read a LWSR block (1002)

Referenced by createZones(), and LightWayTxtText.

## ◆ readMPSR5()

bool LightWayTxtParser::readMPSR5 | ( | MWAWEntry const & | entry | ) |
| protected

read a MPSR block (1005)

Referenced by createZones(), and LightWayTxtText.

## ◆ readPrintInfo()

bool LightWayTxtParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |
| protected

read a PrintInfo block

Referenced by createZones(), and LightWayTxtText.

## ◆ readTOC()

bool LightWayTxtParser::readTOC | ( | MWAWEntry const & | entry | ) |
| protected

read a TOC data block

Referenced by createZones(), and LightWayTxtText.

## ◆ readTOCPage()

bool LightWayTxtParser::readTOCPage | ( | MWAWEntry const & | entry | ) |
| protected

read a TOC page block

Referenced by createZones(), and LightWayTxtText.

## ◆ rsrcAscii()

libmwaw::DebugFile & LightWayTxtParser::rsrcAscii | ( |  | ) |
| protected

a DebugFile used to write what we recognize when we parse the document in rsrc

Referenced by LightWayTxtText, readDocInfo(), readDocument(), readLWSR2(), readMPSR5(), readPrintInfo(), readTOC(), and readTOCPage().

## ◆ rsrcInput()

MWAWInputStreamPtr LightWayTxtParser::rsrcInput | ( |  | ) |
| protected

return the input input

Referenced by LightWayTxtText, readDocInfo(), readDocument(), readLWSR2(), readMPSR5(), readPrintInfo(), readTOC(), readTOCPage(), sendGraphic(), and sendHeaderFooter().

## ◆ sendGraphic()

void LightWayTxtParser::sendGraphic | ( | int | graphId | ) |
| protected

ask the graph parser to send a graph

Referenced by LightWayTxtText.

## ◆ sendHeaderFooter()

bool LightWayTxtParser::sendHeaderFooter | ( | bool | header | ) |
| protected

try to send the header/footer

Referenced by LightWayTxtText, and LightWayTxtParserInternal::SubDocument::parse().

## ◆ textInDataFork()

bool LightWayTxtParser::textInDataFork | ( |  | ) | const
| protected

returns true if the main text is in data fork

Referenced by LightWayTxtText.

## Friends And Related Symbol Documentation

## ◆ LightWayTxtGraph

friend class LightWayTxtGraph
| friend

Referenced by init(), and LightWayTxtGraph.

## ◆ LightWayTxtParserInternal::SubDocument

friend class LightWayTxtParserInternal::SubDocument
| friend

## ◆ LightWayTxtText

friend class LightWayTxtText
| friend

Referenced by init(), and LightWayTxtText.

## Member Data Documentation

## ◆ m_graphParser

std::shared_ptr<LightWayTxtGraph> LightWayTxtParser::m_graphParser
| protected

the graph parser

Referenced by createDocument(), createZones(), init(), LightWayTxtParser(), parse(), and sendGraphic().

## ◆ m_pageSpanSet

bool LightWayTxtParser::m_pageSpanSet
| protected

a flag to know if page span has been set

Referenced by LightWayTxtParser(), readDocument(), and readPrintInfo().

## ◆ m_state

std::shared_ptr<LightWayTxtParserInternal::State> LightWayTxtParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), getColumnInfo(), getPageLeftTop(), init(), LightWayTxtParser(), newPage(), readDocument(), and textInDataFork().

## ◆ m_textParser

std::shared_ptr<LightWayTxtText> LightWayTxtParser::m_textParser
| protected

the text parser

Referenced by createDocument(), createZones(), init(), LightWayTxtParser(), parse(), readDocument(), and sendHeaderFooter().

The documentation for this class was generated from the following files:

- LightWayTxtParser.hxx
- LightWayTxtParser.cxx